import java.awt.Component;
import java.awt.Dimension;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.WindowConstants;

public class EjemploBoxLayout {
	public static void main(String [] args)
	{
		// Se crea la ventana con el BoxLayout
		JFrame v = new JFrame();
		v.getContentPane().setLayout(new BoxLayout(v.getContentPane(),BoxLayout.Y_AXIS));
		
		// Se crea un botn centrado y se aade
		JButton boton1 = new JButton("A");
		boton1.setAlignmentX(Component.CENTER_ALIGNMENT);
		boton1.setPreferredSize(new Dimension(100,100));
		boton1.setMinimumSize(new Dimension(100,100));
		v.getContentPane().add(boton1);
		JButton boton2 = new JButton("B");
		boton2.setAlignmentX(Component.RIGHT_ALIGNMENT);
		v.getContentPane().add(boton2);
		JButton boton3 = new JButton("C");
		boton3.setAlignmentX(Component.LEFT_ALIGNMENT);
		v.getContentPane().add(boton3);
		
		// Se crea una etiqueta centrada y se aade
		JLabel etiqueta = new JLabel("una etiqueta larga");
		etiqueta.setAlignmentX(Component.CENTER_ALIGNMENT);
		v.getContentPane().add(etiqueta);
		
		// Visualizar la ventana
		v.pack();
		v.setVisible(true);
		v.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	}
}
